---
content_template: templates/concept
title: Contribute to Kubernetes docs
linktitle: Contribute
main_menu: true
weight: 80
---

{{% capture overview %}}

If you would like to help contribute to the Kubernetes documentation or website,
we're happy to have your help! Anyone can contribute, whether you're new to the
project or you've been around a long time, and whether you self-identify as a
developer, an end user, or someone who just can't stand seeing typos.

Looking for the [style guide](/docs/contribute/style/style-guide/)?
{{% /capture %}}

{{% capture body %}}

## Types of contributor

- A _member_ of the Kubernetes organization has [signed the CLA](/docs/contribute/start#sign-the-cla)
  and contributed some time and effort to the project. See
  [Community membership](https://github.com/kubernetes/community/blob/master/community-membership.md)
  for specific criteria for membership.
- A SIG Docs _reviewer_ is a member of the Kubernetes organization who has
  expressed interest in reviewing documentation pull requests and who has been
  added to the appropriate Github group and `OWNERS` files in the Github
  repository, by a SIG Docs Approver.
- A SIG Docs _approver_ is a member in good standing who has shown a continued
  commitment to the project and is granted the ability to merge pull requests
  and thus to publish content on behalf of the Kubernetes organization.
  Approvers can also represent SIG Docs in the larger Kubernetes community.
  Some of the duties of a SIG Docs approver, such as coordinating a release,
  require a significant time commitment.

## Ways to contribute

This list is divided into things anyone can do, things Kubernetes organization
members can do, and things that require a higher level of access and familiarity
with SIG Docs processes. Contributing consistently over time can help you
understand some of the tooling and organizational decisions that have already
been made.

This is not an exhaustive list of ways you can contribute to the Kubernetes
documentation, but it should help you get started.

- [Anyone](/docs/contribute/start/)
  - File actionable bugs
- [Member](/docs/contribute/start/)
  - Improve existing docs
  - Bring up ideas for improvement on Slack or SIG docs mailing list
  - Improve docs accessibility
  - Provide non-binding feedback on PRs
  - Write a blog post or case study
- [Reviewer](/docs/contribute/intermediate/)
  - Document new features
  - Triage and categorize issues
  - Review PRs
  - Create diagrams, graphics assets, and embeddable screencasts / videos
  - Localization
  - Contribute to other repos as a docs representative
  - Edit user-facing strings in code
  - Improve code comments, Godoc
- [Approver](/docs/contribute/advanced/)
  - Publish contributor content by approving and merging PRs
  - Participate in a Kubernetes release team as a docs representative
  - Propose improvements to the style guide
  - Propose improvements to docs tests
  - Propose improvements to the Kubernetes website or other tooling

{{% /capture %}}
