---
title: Container Storage Interface (CSI)
id: csi
date: 2018-06-25
full_link: https://kubernetes.io/docs/concepts/storage/volumes/#csi
short_description: >
    The Container Storage Interface (CSI) defines a standard interface to expose storage systems to containers.


aka: 
tags:
- storage 
---
 The Container Storage Interface (CSI) defines a standard interface to expose storage systems to containers.

<!--more--> 

CSI allows vendors to create custom storage plugins for Kubernetes without adding them to the Kubernetes repository (out-of-tree plugins). To use a CSI driver from a storage provider, you must first [deploy it to your cluster](https://kubernetes-csi.github.io/docs/Setup.html). You will then be able to create a {{< glossary_tooltip text="Storage Class" term_id="storage-class" >}} that uses that CSI driver.

* [CSI in the Kubernetes documentation](https://kubernetes.io/docs/concepts/storage/volumes/#csi)
* [List of available CSI drivers](https://kubernetes-csi.github.io/docs/Drivers.html)
